/***********************************************************************/
/** 	
/** 	2016 SkacikPL
/** 	
/***********************************************************************/
statemachine class FirstPersonCamera extends CStaticCamera
{
		var testcomp : CComponent;
		var desiredrot : EulerAngles;
		var camrot : EulerAngles;
		var tprot : EulerAngles;
		var lastrot : EulerAngles;
		var lastmouseX : float;
		var lastmouseY : float;
		var correctedX : float;
		var correctedY : float;
		var originalFOV	: float;
		var zoominfinished : bool;
		var zoomoutfinished : bool;
		private var curfov : float;
		editable var zoomspeed	: float;
		var cameralerp		: float;
		var islerping		: bool;
		var listenerhook	: FPHookListener;
		var xonlylerp		: float;
		var offsetpos		: Vector;
		var Zcorrect		: bool;		default Zcorrect = true;
		var comprot			: EulerAngles;
		var Ysensitivity	: float;	default Ysensitivity = 	1;
		var Xsensitivity	: float;	default Xsensitivity = 1;
		var storeddofint	: int;
		var controllerYinverted : bool;
		var controllermult	: int;		default controllermult = 25;

//This runs when actual w2ent is spawned in the world
	event OnSpawned( spawnData : SEntitySpawnData )
	{
		//Start blending view to the FP camera
		this.Run();
		theGame.FadeOutAsync(0.5);
		this.SetCameraState(CS_AimThrow);
		this.AddTimer( 'DelayedRun', 1.0, false );
		//Declare our actual camera
		testcomp = this.GetComponentByClassName('CCameraComponent');
		//Some looping timed logic
		this.AddTimer( 'CorrectFPCamera', 0.005, true );
		if(FactsQuerySum("FPTIMESPENT") < 65535)
			this.AddTimer( 'TrackSpentTime', 60.0f, true );	
		
		this.AddTimer( 'RegisterInputListener', 2, false );
		//Make sure zoom logic starts fresh
		zoominfinished = true;
		zoomoutfinished = true;
		zoomspeed = 0.001;
		setcrosshair(true);
		
		//Handle persistent settings
		if(FactsDoesExist("FPZCORRECT") && FactsQuerySum("FPZCORRECT") == 0)
		{
			Zcorrect = false;
		}
		
		if(FactsDoesExist("FPFOV"))		
		{
			((CCameraComponent)testcomp).setfov(FactsQuerySum("FPFOV"));
		}
		
		if(FactsDoesExist("FPXSENS") && FactsDoesExist("FPYSENS"))		
		{
			setsens(FactsQuerySum("FPXSENS"),FactsQuerySum("FPYSENS"));
		}	

		if(FactsDoesExist("FPDOF") && FactsQuerySum("FPDOF") == 1)		
		{
			fpdof(true);
		}
		
		if(FactsDoesExist("FPDONOTDISTURB") && FactsQuerySum("FPDONOTDISTURB") == 1)		
		{
			((CActor)thePlayer).SetTemporaryAttitudeGroup( 'q104_avallach_friendly_to_all', AGP_Default );		
		}		
		
		if(FactsDoesExist("FPINVERTED") && FactsQuerySum("FPINVERTED") == 1)		
		{
			setinvert(true);
		}		
		
		theSound.SoundEvent("gui_global_submenu_whoosh");
		
		LogMessage("<font color=\"#C20095\">You have entered first person mode.</font><br><font color=\"#C20095\">Type </font><font color=\"#FF3939\" size=\"30\"><b>fphelp</b></font><font color=\"#C20095\"> in console to view help screen.</font>");	
	}

//Are we on a ladder?
	function isonladder() : bool
	{
		var states : CExplorationStateManager;
		states = thePlayer.substateManager;
		
		if(states.GetStateCur() == 'Interaction' && states.m_SharedDataO.GetCurentExplorationType() == ET_Ladder)
			return true;
			
		return false;
	}
	
//Moved to actual FPC class
	function hidehead()
	{
		var template : CEntityTemplate;
		var l_comp : CComponent;
		var inv : CInventoryComponent;
		var witcher : W3PlayerWitcher;
		var ids : array<SItemUniqueId>;
		var size : int;
		var i : int;
		var l_actor : CActor;
		
				l_actor = thePlayer;
	
				if(!thePlayer.IsCiri())
				{
						witcher = GetWitcherPlayer();
						inv = thePlayer.GetInventory();
		
						ids = witcher.inv.GetItemsByCategory( 'hair' );
		
						size = ids.Size();
		
						if( size > 0 )
						{
			
							for( i = 0; i < size; i+=1 )
							{
								if(inv.IsItemMounted( ids[i] ) )
									{
										inv.DespawnItem(ids[i]);
									}
							}
			
						}
		
					ids.Clear();
					initheadmesh();
				}
				else
				{
					l_comp = l_actor.GetComponentByClassName( 'CAppearanceComponent' );
					template = (CEntityTemplate)LoadResource("characters\models\main_npc\ciri\c_06_wa__ciri.w2ent", true);
					((CAppearanceComponent)l_comp).ExcludeAppearanceTemplate(template);
					template = (CEntityTemplate)LoadResource("characters\models\main_npc\ciri\c_01_wa__ciri.w2ent", true);
					((CAppearanceComponent)l_comp).ExcludeAppearanceTemplate(template);
					template = (CEntityTemplate)LoadResource("characters\models\main_npc\ciri\h_01_wa__ciri.w2ent", true);
					((CAppearanceComponent)l_comp).ExcludeAppearanceTemplate(template);
					template = (CEntityTemplate)LoadResource("characters\models\main_npc\ciri\h_01_wa__ciri_masked.w2ent", true);
					((CAppearanceComponent)l_comp).ExcludeAppearanceTemplate(template);
					template = (CEntityTemplate)LoadResource("characters\models\main_npc\ciri\h_01_wa__ciri_wounded.w2ent", true);
					((CAppearanceComponent)l_comp).ExcludeAppearanceTemplate(template);
					template = (CEntityTemplate)LoadResource("characters\models\main_npc\ciri\h_04_wa__ciri_crying.w2ent", true);
					((CAppearanceComponent)l_comp).ExcludeAppearanceTemplate(template);
					template = (CEntityTemplate)LoadResource("characters\models\main_npc\ciri\l_01_wa__lingerie_ciri.w2ent", true);
					((CAppearanceComponent)l_comp).ExcludeAppearanceTemplate(template);	
				}
	
	}	

//Should look more pro now.
	timer function DelayedRun( time : float, id : int)
	{
		hidehead();
		this.AddTimer( 'DelayedFadeIn', 0.1, false );
	}
	
	timer function DelayedFadeIn( time : float, id : int)
	{
		theGame.FadeInAsync(0.5);
	}
	
//Set Y axis inversion (controller only)
	function setinvert(val : bool)
	{
		controllerYinverted = val;
	}
	
//Are we inverted?
	function getinverted() : bool
	{
		return controllerYinverted;
	}

//Enable FP specific DOF
	function fpdof(enable : bool)
	{
		var environment : CEnvironmentDefinition;

		environment = ( CEnvironmentDefinition )LoadResource( "environment\definitions\custom\fpdof.env", true );

		if(enable)
		{
			storeddofint = ActivateEnvironmentDefinition(environment,100,1,1.5);
			theGame.SetEnvironmentID(storeddofint);
		}
		else
		{
			DeactivateEnvironment(storeddofint,1.5);
		}
	}

//Get whether DOF is enabled
	function getdof() : bool
	{
		if(storeddofint != 0)
		{
			return true;
		}
		else
		{
			return false;	
		}

	}
	
//Call to set sensitivity values	
	function setsens(Xval, Yval : int)
	{
		Xsensitivity = StringToFloat(Xval);
		Ysensitivity = StringToFloat(Yval);
	
		lastmouseX = 0;
		lastmouseY = 0;
	}
	
//Print to log
	public function LogMessage(m : string)
	{
		var str : string;	
	
		str = ReplaceTagsToIcons(m);
	
		theGame.GetGuiManager().ShowNotification(str, 4000);
	}
	
//Display crosshair
	function setcrosshair(enabled : bool)
	{
		var hud : CR4ScriptedHud;
		var module : CR4HudModuleCrosshair;
	

		hud = (CR4ScriptedHud)theGame.GetHud();
		module = (CR4HudModuleCrosshair)hud.GetHudModule("CrosshairModule");
		module.ShowElement( enabled, false );	
	}
	
//Just make sure we know who's our listener
	function setlistener(val : FPHookListener)
	{
		listenerhook = val;
	}
	
//Registering input listeners for custom controls
	timer function RegisterInputListener( time : float, id : int)
	{
		//Shared
		theInput.RegisterListener( this, 'OnLeaveFP', 'DebugInput' );		
	
		//Geralt
		theInput.RegisterListener( this, 'OnTurn180', 'SteelSword' );
		theInput.RegisterListener( this, 'OnCenterView', 'SilverSword' );
		theInput.RegisterListener( this, 'OnZoomView', 'Focus' );

		//Ciri
		theInput.RegisterListener( this, 'OnTurn180', 'CiriDrawWeapon' );
		theInput.RegisterListener( this, 'OnCenterView', 'CiriDrawWeaponAlternative' );
		
		if(thePlayer.IsCiri())
			theInput.RegisterListener( this, 'OnZoomView', 'ThrowItem' );
	}
	
//Fired when player leaves first person
	event OnLeaveFP( action : SInputAction )
	{
		if( IsPressed( action ) )
		{
			ExitFP();
		}
	}
	
//Zoom in input event
	event OnZoomView( action : SInputAction )
	{
		//If we click and hold RMB
		if( IsPressed( action ) )
		{
			//Zoom in from the beginning
			if(zoominfinished && zoomoutfinished)
			{
				//We better make sure we know what was our original FOV that we need to (eventually) come back to
				originalFOV = FactsQuerySum("FPFOV");
				
				if(FactsQuerySum("FPFOV") == 0)
					originalFOV = ((CCameraComponent)testcomp).getfov();
					
				this.AddTimer( 'ZoomIn', zoomspeed, true );			
			}
			
			//We were zooming out but now we have to zoom in again
			if(zoominfinished && !zoomoutfinished)
			{
				this.RemoveTimer( 'ZoomOut' );
				zoomoutfinished = true;
				this.AddTimer( 'ZoomIn', zoomspeed, true );			
			}			
		}
		//If we release RMB
		else if( IsReleased( action ) )
		{
			//We were fully zoomed in but player released RMB - time to zoom out
			if(zoominfinished && zoomoutfinished)
			{
				this.AddTimer( 'ZoomOut', zoomspeed, true );
			}
			
			//Player released RMB while we were zooming in, cancel the process and zoom out
			if(!zoominfinished && zoomoutfinished)
			{
				this.RemoveTimer( 'ZoomIn' );
				zoominfinished = true;
				this.AddTimer( 'ZoomOut', zoomspeed, true );
			}
		}
	}

	timer function ZoomIn( time : float, id : int)
	{
		zoominfinished = false;
		curfov = ((CCameraComponent)testcomp).getfov();		
		
		//We always provide player with 4.5x zoom in regards to his original FOV
		if(curfov > (originalFOV / 4.5) && zoomoutfinished)
		{
			((CCameraComponent)testcomp).setfov(((CCameraComponent)testcomp).getfov() - 1);
		}
		
		if(curfov == (originalFOV / 4.5) && zoomoutfinished)
		{
			this.RemoveTimer( 'ZoomIn' );	
			zoominfinished = true;		
		}
	}
	
	timer function ZoomOut( time : float, id : int)
	{
		zoomoutfinished = false;
		curfov = ((CCameraComponent)testcomp).getfov();		
		
		if(curfov < originalFOV && zoominfinished)
		{
			((CCameraComponent)testcomp).setfov(((CCameraComponent)testcomp).getfov() + 1);
		}

		if(curfov == originalFOV && zoominfinished)
		{
			this.RemoveTimer( 'ZoomOut' );	
			zoomoutfinished = true;		
		}		
	}
	
//When we need to turn around in place - PLAYS ANIMATION FROM B&W!
	event OnTurn180( action : SInputAction )
	{
		if( IsPressed( action ) )
		{
			//We also call an event to reset the view so player won't get disoriented
			OnCenterView(action);

			//Only turn if player has B&W installed as that animation is from ep2 dlc\fpcamfix\data\gameplay\camera\firstperson
				if(!thePlayer.IsCiri())
				{
					thePlayer.PlayerStartAction( 1,'high_standing_proud_turn180_left' );					
				}
				else
				{
					thePlayer.PlayerStartAction( 1, 'high_standing_determined_turn180_left' );
				}

		}
	}	
	
//Center view so player will know what's the forward direction
	event OnCenterView( action : SInputAction )
	{
		var resetrot : EulerAngles;
		
		if( IsPressed( action ) && !islerping )
		{
			cameralerp = 0;
			this.AddTimer( 'LerpCamera', 0.001, true );			
		}
	}
	
//Actual view reset logic - timed linear interpolation from current position to center (0;0)
	timer function LerpCamera( time : float, id : int)
	{
		if(lastmouseX != 0 && lastmouseY != 0)
		{
			islerping = true;
			lastmouseY = LerpF( cameralerp, lastmouseY, 0 );
			lastmouseX = LerpF( cameralerp, lastmouseX, 0 );	
		
			//For some reason we have to clamp or we'll miss 0, looping the logic.
			cameralerp = ClampF(cameralerp + 0.05, 0, 1);
		}
		else
		{
				//Once view has been reset logic can be removed
				this.RemoveTimer( 'LerpCamera' );
				islerping = false;	
		}
	}
	
//Same as above but only for Yaw, useful for allowing player walk forward with mouse look
		timer function LerpCameraXonly( time : float, id : int)
	{
		if(lastmouseX != 0)
		{
			lastmouseX = LerpF( xonlylerp, lastmouseX, 0 );	
			xonlylerp = ClampF(xonlylerp + 0.01, 0, 1);
		}
		else
		{
				this.RemoveTimer( 'LerpCameraXonly' );
				xonlylerp = 0;
		}	
	}
	
//Just for keks (though it's probably a shitty idea to do it this way)
	timer function TrackSpentTime( time : float, id : int )
	{
		//let's limit it to Uint16, it's 1092 hours either way
		if(FactsQuerySum("FPTIMESPENT") < 65535)
			FactsSet( "FPTIMESPENT", FactsQuerySum("FPTIMESPENT") + 1);		
	}
	
//Pretty much handles head bob compensation and basic mouse controls
	timer function CorrectFPCamera( time : float, id : int)
	{
		if(controllerYinverted)
		{
			controllermult = -25;
		}
		else
		{
			controllermult = 25;
		}
		
		//Up/down axis, active if we're moving the mouse and not centering the view
		if(theInput.GetActionValue( 'GI_MouseDampY' ) != 0 && !islerping || theInput.GetActionValue( 'GI_AxisRightY' ) != 0 && !islerping)
		{
			lastmouseY = ClampF(lastmouseY + theInput.GetActionValue( 'GI_MouseDampY' ) * -1 + (theInput.GetActionValue( 'GI_AxisRightY' ) * controllermult),(-650 / Ysensitivity),(800 / Ysensitivity));
		}
		
		//Left/Right axis, also only active when we're moving the mouse whilst view is not being centered
		if(theInput.GetActionValue( 'GI_MouseDampX' ) != 0 && !islerping || theInput.GetActionValue( 'GI_AxisRightX' ) != 0 && !islerping)
		{
			this.RemoveTimer( 'LerpCameraXonly' );
			xonlylerp = 0;			
			lastmouseX = ClampF(lastmouseX + theInput.GetActionValue( 'GI_MouseDampX' ) * -1 + (theInput.GetActionValue( 'GI_AxisRightX' ) * -25),(-1200 / Xsensitivity),(1300 / Xsensitivity));
		}	
		
		
		camrot = this.GetWorldRotation();
		
		desiredrot = thePlayer.GetWorldRotation();
		//Make sure camera is actually heading in the right direction (TODO: We also need a deadzone)
		desiredrot.Yaw = (thePlayer.GetHeading() - this.GetHeading());			
		lastrot = desiredrot;
		//apply mouse controls
		lastrot.Pitch = lastrot.Pitch + lastmouseY * (0.1 * Ysensitivity);
		lastrot.Yaw = lastrot.Yaw + lastmouseX * (0.05 * Xsensitivity);
		
		//Camera is bound to the root for stability so we need to manually adjust Z/Y positions to match head bone
		offsetpos = Vector(0,0,0,1);
		if(Zcorrect)
		{
			if(!thePlayer.IsCiri())
			{
				offsetpos.Z = VecDistance(thePlayer.GetBoneWorldPosition('Root'), thePlayer.GetBoneWorldPosition('head')) - 1.73;			
			}
			else
			{
				offsetpos.Z = VecDistance(thePlayer.GetBoneWorldPosition('Root'), thePlayer.GetBoneWorldPosition('head')) - 1.8;	
			}
		
		}
		offsetpos.X = 0;
		
		if(!isonladder() && !thePlayer.IsSwimming () )
		{
			offsetpos.Y = VecDistance(this.GetWorldPosition(), thePlayer.GetBoneWorldPosition('head') - 0.21);		
		}
		else
		{
			offsetpos.Y = VecDistance(this.GetWorldPosition(), thePlayer.GetBoneWorldPosition('head'));			
		}
		
		//offset roll
		comprot = thePlayer.GetWorldRotation();
		lastrot.Roll = comprot.Roll * -1;

		
		//Apply final controls and offsets for the tick	
		testcomp.SetRotation(lastrot);
		testcomp.SetPosition(offsetpos);
		
		//Yaw centering logic when player is moving and not moving his mouse
		if(theInput.GetActionValue( 'GI_MouseDampX' ) == 0 && !islerping && thePlayer.GetMovingAgentComponent().GetSpeed() > 0)
		{
			this.AddTimer( 'LerpCameraXonly', 0.001, true );
		}	

		//Setup automated exit points
		if( thePlayer.IsInCombatState() || theGame.IsDialogOrCutscenePlaying() || thePlayer.GetIsHorseMounted() || thePlayer.GetActivePoster() )
		{
			this.RemoveTimer( 'CorrectFPCamera' );	
			this.RemoveTimer( 'TrackSpentTime' );
			ExitFP();
		}
	}
	
	function setzcorrect(val : bool)
	{
		Zcorrect = val;
	}
	
	function getzcorrect() : bool
	{
		return Zcorrect;
	}
	
//Grouped logic fired when leaving FP mode
	function ExitFP()
	{		
		theGame.FadeOutAsync(0.2);
		
		//For some weird reason that's the only way how it works as intended
		if(!theGame.IsDialogOrCutscenePlaying())
		{
			if(!thePlayer.GetIsHorseMounted())
			{
				if(!thePlayer.GetActivePoster())
				{
					theGame.GetGameCamera().Activate( 1 );					
				}			
			}
		}
		this.AddTimer( 'DelayedRestore', 1, false );
		//Shared
		theInput.UnregisterListener( this, 'DebugInput' );

		//Geralt
		theInput.UnregisterListener( this, 'SteelSword' );
		theInput.UnregisterListener( this, 'SilverSword' );	
		theInput.UnregisterListener( this, 'Focus' );
		
		//Ciri
		theInput.UnregisterListener( this, 'CiriDrawWeapon' );
		theInput.UnregisterListener( this, 'CiriDrawWeaponAlternative' );
		
		if(thePlayer.IsCiri())
			theInput.UnregisterListener( this, 'ThrowItem' );		

		thePlayer.GetInputHandler().Initialize(false);
		setcrosshair(false);
		if(FactsDoesExist("FPDOF") && FactsQuerySum("FPDOF") == 1)		
		{
			fpdof(false);
		}
		if(FactsDoesExist("FPDONOTDISTURB") && FactsQuerySum("FPDONOTDISTURB") == 1)		
		{
			((CActor)thePlayer).SetTemporaryAttitudeGroup( 'player', AGP_Default );		
		}	
		
		this.RemoveTimer( 'TrackSpentTime' );		
		this.AddTimer( 'DelayedDestroy', 3.01, false );
		this.AddTimer( 'DelayedFadeIn', 1.05 );
		
		theSound.SoundEvent("gui_global_submenu_whoosh");
		
		LogMessage("<font color=\"#C20095\">You have left first person mode.</font>");		
	}
	
//Spawn invisible head model
	function initheadmesh()
	{
		var l_actor : CActor;
		var l_comp : CComponent;
		var acs : array< CComponent >;		


		l_actor = thePlayer;
		l_comp = l_actor.GetComponentByClassName( 'CAppearanceComponent' );	
		
		if(!thePlayer.IsCiri())
		{
			acs = thePlayer.GetComponentsByClassName( 'CHeadManagerComponent' );
			( ( CHeadManagerComponent ) acs[0] ).SetCustomHead( 'head_firstperson' );					
		}
		else
		{
			((CAppearanceComponent)l_comp).IncludeAppearanceTemplate((CEntityTemplate)LoadResource("dlc\fpcamfix\data\gameplay\camera\firstpersonheadCiri1.w2ent", true));
			((CAppearanceComponent)l_comp).IncludeAppearanceTemplate((CEntityTemplate)LoadResource("dlc\fpcamfix\data\gameplay\camera\firstpersonheadCiri2.w2ent", true));
			((CAppearanceComponent)l_comp).IncludeAppearanceTemplate((CEntityTemplate)LoadResource("dlc\fpcamfix\data\gameplay\camera\firstpersonheadCiri3.w2ent", true));				
		}

	}
	
//Remove invisible head model
	function removeheadmesh()
	{
		var l_actor : CActor;
		var l_comp : CComponent;
		var acs : array< CComponent >;
		var barberHead : name;		


		l_actor = thePlayer;
		l_comp = l_actor.GetComponentByClassName( 'CAppearanceComponent' );	
		
		if(!thePlayer.IsCiri())
		{
			acs = thePlayer.GetComponentsByClassName( 'CHeadManagerComponent' );		
			barberHead = thePlayer.GetRememberedCustomHead();
		
			if( IsNameValid(barberHead) )
			{
				( ( CHeadManagerComponent ) acs[0] ).SetCustomHead( barberHead );
			}
			else
			{
				( ( CHeadManagerComponent ) acs[0] ).RemoveCustomHead();
			}
		}
		else
		{
			((CAppearanceComponent)l_comp).ExcludeAppearanceTemplate((CEntityTemplate)LoadResource("dlc\fpcamfix\data\gameplay\camera\firstpersonheadCiri1.w2ent", true));
			((CAppearanceComponent)l_comp).ExcludeAppearanceTemplate((CEntityTemplate)LoadResource("dlc\fpcamfix\data\gameplay\camera\firstpersonheadCiri2.w2ent", true));
			((CAppearanceComponent)l_comp).ExcludeAppearanceTemplate((CEntityTemplate)LoadResource("dlc\fpcamfix\data\gameplay\camera\firstpersonheadCiri3.w2ent", true));			
		}
	}	
	
//We also need to restore actual player head and hair when leaving FP
	timer function DelayedRestore( time : float, id : int)
	{
		if(!thePlayer.IsCiri())
		{
			removeheadmesh();
			CheckHairItem();
		}
		else
		{
			RestoreCiri();
		}
	}
	
//Restore head and hair for Ciri
	function RestoreCiri()
	{
		var l_comp : CComponent;
		var template : CEntityTemplate;	
		
		l_comp = thePlayer.GetComponentByClassName( 'CAppearanceComponent' );		
		
		template = (CEntityTemplate)LoadResource("characters\models\main_npc\ciri\c_01_wa__ciri.w2ent", true);
		((CAppearanceComponent)l_comp).IncludeAppearanceTemplate(template);
		template = (CEntityTemplate)LoadResource("characters\models\main_npc\ciri\h_01_wa__ciri.w2ent", true);
		((CAppearanceComponent)l_comp).IncludeAppearanceTemplate(template);		
	}

//Restore Hair
	private function CheckHairItem()
	{
		var ids : array<SItemUniqueId>;
		var i   : int;
		var itemName : name;
		var hairApplied : bool;
		
		ids = thePlayer.inv.GetItemsByCategory('hair');
		
		for(i=0; i<ids.Size(); i+= 1)
		{
			itemName = thePlayer.inv.GetItemName( ids[i] );
			
			if( itemName != 'Preview Hair' )
			{
				if( hairApplied == false )
				{
					thePlayer.inv.MountItem( ids[i], false );
					hairApplied = true;
				}
				else
				{
					thePlayer.inv.RemoveItem( ids[i], 1 );
				}
				
			}
		}
		
		if( hairApplied == false )
		{
			ids = thePlayer.inv.AddAnItem('Half With Tail Hairstyle', 1, true, false);
			thePlayer.inv.MountItem( ids[0], false );
		}
		
	}	
	
//Restore head
	private function CheckHeadItem()
	{
		var ids : array<SItemUniqueId>;
		var i   : int;
		var itemName : name;
		var headApplied : bool;
		
		ids = thePlayer.inv.GetItemsByCategory('head');
		
		for(i=0; i<ids.Size(); i+= 1)
		{
			itemName = thePlayer.inv.GetItemName( ids[i] );
			
				if( headApplied == false )
				{
					thePlayer.inv.MountItem( ids[i], false );
					headApplied = true;
				}
				else
				{
					thePlayer.inv.RemoveItem( ids[i], 1 );
				}
				
			
		}
		
		if( headApplied == false )
		{
			ids = thePlayer.inv.AddAnItem('head_0', 1, true, false);
			thePlayer.inv.MountItem( ids[0], false );
		}
		
	}	
	
//Once we're entirely done with exiting logic - commit suicide
	timer function DelayedDestroy( time : float, id : int)
	{
		listenerhook.StartListener(true);
		this.Destroy();
	}
}

//Set camera FOV through console
	exec function fpsetfov(val : float)
	{
		var ent : CEntity;
		var l_comp : CComponent;
		
		ent = theGame.GetEntityByTag( 'FPSCAMERA' );
		l_comp = ent.GetComponentByClassName('CCameraComponent');
	
		if(val > 110)
			val = 110;
		
		if(val <= 0)
			val = 1;
	
		theSound.SoundEvent("gui_global_clock_tick_stop");	
		((CCameraComponent)l_comp).setfov(val);
		((FirstPersonCamera)ent).LogMessage("<font color=\"#C20095\">FOV set to: </font>" + "<font color=\"#6D6169\">" + RoundF(((CCameraComponent)l_comp).getfov()) + "</font>");	
		FactsSet("FPFOV",RoundF(val));	
	}

//Enable do-not-disturb mode
	exec function fpdonotdisturb(val : bool)
	{
		var ent : CEntity;
		var booltoint : int;
	
	//REALLY?
		if(val)
		{
			booltoint = 1;
			((CActor)thePlayer).SetTemporaryAttitudeGroup( 'q104_avallach_friendly_to_all', AGP_Default );		
		}
		else
		{
			booltoint = 0;
			((CActor)thePlayer).SetTemporaryAttitudeGroup( 'player', AGP_Default );			
		}
		
		ent = theGame.GetEntityByTag( 'FPSCAMERA' );
		theSound.SoundEvent("gui_global_clock_tick_stop");	
		((FirstPersonCamera)ent).LogMessage("<font color=\"#C20095\">Do not disturb mode enabled: </font>" + "<font color=\"#6D6169\">" + val + "</font>");
		FactsSet("FPDONOTDISTURB",booltoint);	
	}

//Enable disable Z correction
	exec function fpzcorrect(val : bool)
	{
		var ent : CEntity;
		var booltoint : int;
	
	//REALLY?
		if(val)
		{
			booltoint = 1;
		}
		else
		{
			booltoint = 0;
		}

		ent = theGame.GetEntityByTag( 'FPSCAMERA' );
		theSound.SoundEvent("gui_global_clock_tick_stop");		
		((FirstPersonCamera)ent).setzcorrect(booltoint);
		((FirstPersonCamera)ent).LogMessage("<font color=\"#C20095\">Head bobbing enabled: </font>" + "<font color=\"#6D6169\">" + ((FirstPersonCamera)ent).getzcorrect() + "</font>");
		FactsSet("FPZCORRECT",booltoint);	
	}

//FP DOF
	exec function fpsetdof(val : bool)
	{
		var ent : CEntity;
		var booltoint : int;
	
	//REALLY?
		if(val)
		{
			booltoint = 1;
		}
		else
		{
			booltoint = 0;
		}
		
		ent = theGame.GetEntityByTag( 'FPSCAMERA' );
		theSound.SoundEvent("gui_global_clock_tick_stop");		
		((FirstPersonCamera)ent).fpdof(val);
		((FirstPersonCamera)ent).LogMessage("<font color=\"#C20095\">FP DOF enabled: </font>" + "<font color=\"#6D6169\">" + ((FirstPersonCamera)ent).getdof() + "</font>");
		FactsSet("FPDOF",booltoint);	
	}
	
//FP Inverted Y axis
	exec function fpinverty(val : bool)
	{
		var ent : CEntity;
		var booltoint : int;
	
	//REALLY?
		if(val)
		{
			booltoint = 1;
		}
		else
		{
			booltoint = 0;
		}
		
		ent = theGame.GetEntityByTag( 'FPSCAMERA' );
		theSound.SoundEvent("gui_global_clock_tick_stop");		
		((FirstPersonCamera)ent).setinvert(val);
		((FirstPersonCamera)ent).LogMessage("<font color=\"#C20095\">FP Controller vertical axis inverted: </font>" + "<font color=\"#6D6169\">" + ((FirstPersonCamera)ent).getinverted() + "</font>");
		FactsSet("FPINVERTED",booltoint);	
	}	

//Initialize input listener
	exec function fphook()
	{
		var listener	: FPHookListener;
		var ent : CEntity;	
	
		listener = new FPHookListener in thePlayer.GetInputHandler();
		listener.StartListener();
	}

//show settings
	exec function fpsettings()
	{
		var title : string;
		var fovmess : string;
		var headbob : string;
		var headbobval : string;
		var mouseXval	: string;
		var mouseYval	: string;
		var dofmess		: string;
		var dofval		: string;
		var disturbmess	: string;
		var disturbval	: string;
		var invertmess	: string;
		var invertval	: string;
		var noentmess	: string;
		var ent : CEntity;
		var l_comp : CComponent;
		
		ent = theGame.GetEntityByTag( 'FPSCAMERA' );
		l_comp = ent.GetComponentByClassName('CCameraComponent');

		if(FactsQuerySum("FPZCORRECT") == 1)
			headbobval = "true";
	
		if(FactsQuerySum("FPZCORRECT") == 0)
			headbobval = "false";
	
		if(FactsQuerySum("FPDOF") == 1)
			dofval = "true";
	
		if(FactsQuerySum("FPDOF") == 0)
			dofval = "false";	
	
		if(FactsQuerySum("FPDONOTDISTURB") == 1)
			disturbval = "true";
	
		if(FactsQuerySum("FPDONOTDISTURB") == 0)
			disturbval = "false";		
			
		if(FactsQuerySum("FPINVERTED") == 1)
			invertval = "true";
	
		if(FactsQuerySum("FPINVERTED") == 0)
			invertval = "false";	
			
		noentmess = "<font color=\"#FF0000\" size=\"26\" ><br><br><center><b>No first person camera entity found!</b></center></font>";

		if(ent)
			noentmess = "";

		title = "<font color=\"#FAAC34\" size=\"28\" ><u>First person mode settings</u></font>";
		fovmess = "<font color=\"#40E0D0\">FOV: " + RoundF(FactsQuerySum("FPFOV")) + "</font>";
		headbob = "<font color=\"#C8A2C8\">Head bobbing enabled: " + headbobval + "</font>";
		mouseXval = "<font color=\"#FD9E81\">Mouse X axis sensitivity(horizontal): " + RoundF(FactsQuerySum("FPXSENS")) + "</font>";
		mouseYval = "<font color=\"#9692B2\">Mouse Y axis sensitivity(vertical): " + RoundF(FactsQuerySum("FPYSENS")) + "</font>";
		dofmess = "<font color=\"#95C200\">First person depth of field enabled: " + dofval + "</font>";
		disturbmess = "<font color=\"#C047AD\">Do not disturb mode enabled: " + disturbval + "</font>";
		invertmess = "<font color=\"#9F86FF\">Controller Y axis inverted: " + invertval + "</font>";

		theSound.SoundEvent("gui_global_panel_open");
		theGame.GetGuiManager().ShowUserDialogAdv(0, title, "<br><p align=\"justify\">" + fovmess + "<br>" + headbob + "<br>" + mouseXval + "<br>" + mouseYval + "<br>" + dofmess + "<br>" + disturbmess + "<br>" + invertmess + "<br></p>" + noentmess + "<br>", false, UDB_Ok);
	}

//show time spent in first person mode
	exec function fptime()
	{
		var title : string;
		var timemess : string;
		var rank	: string;
		var conj	: string;

		conj = "s.";

		if(FactsQuerySum("FPTIMESPENT") == 1)
			conj = ".";


		title = "<font color=\"#FAAC34\" size=\"28\" ><u>Time spent in first person mode</u></font>";
		timemess = "Time spent in first person mode: " + FactsQuerySum("FPTIMESPENT") + " minute" + conj;

		if(FactsQuerySum("FPTIMESPENT") >= 65535)
			timemess = "Time spent in first person mode: 65535+ minutes.";


		//Setup the ranks
		if(FactsQuerySum("FPTIMESPENT") <= 14)
			rank = "<font color=\"#F6546A\"><b>A TOURIST</b></font>";
	
		if(FactsQuerySum("FPTIMESPENT") >= 15)
			rank = "<font color=\"#FD7D5F\"><b>AN OBSERVER</b></font>";
	
		if(FactsQuerySum("FPTIMESPENT") >= 30)
			rank = "<font color=\"#839D57\"><b>AN EXPLORER</b></font>";
	
		if(FactsQuerySum("FPTIMESPENT") >= 45)
			rank = "<font color=\"#00A386\"><b>A DISCOVERER</b></font>";
	
		if(FactsQuerySum("FPTIMESPENT") >= 60)
			rank = "<font color=\"#00c6d2\"><b>FAN OF NEW EXPERIENCES</b></font>";
	
		if(FactsQuerySum("FPTIMESPENT") >= 90)
			rank = "<font color=\"#41E9A8\"><b>HOOKED ON THE NEW PERSPECTIVE</b></font>";

		if(FactsQuerySum("FPTIMESPENT") >= 120)
			rank = "<font color=\"#FDD8C5\"><b>RELENTLESS CURIOSITY</b></font>";
	
		if(FactsQuerySum("FPTIMESPENT") >= 180)
			rank = "<font color=\"#FDEBB9\"><b>EXPERIENCING THE WORLD ANEW</b></font>";
	
		if(FactsQuerySum("FPTIMESPENT") >= 240)
			rank = "<font color=\"#AE991E\"><b>EVERYWHERE ON FOOT</b></font>";
	
		if(FactsQuerySum("FPTIMESPENT") >= 300)
			rank = "<font color=\"#F9DB2B\"><b>PROBABLY AFK</b></font>";


		theSound.SoundEvent("gui_global_panel_open");
		theGame.GetGuiManager().ShowUserDialogAdv(0, title, "<br><p align=\"justify\">" + timemess + "</p><br><br><p align=\"center\">" + rank + "</p>", false, UDB_Ok);
	}

//Ingame help
	exec function fphelp()
	{
		var title : string;
		var message : string;
		var userpart : string;
		var mousepart : string;
		var mmbpart		: string;
		var bracketOpeningSymbol : string;
		var bracketClosingSymbol : string;

		userpart = theGame.GetActiveUserDisplayName();
		if(userpart != "")
		{
			userpart = ", <font color=\"#FFFFFF\"><i>" + theGame.GetActiveUserDisplayName() + "</i></font>.";
		}
		else
		{
			userpart = "!";
		}

		GetBracketSymbols(bracketOpeningSymbol, bracketClosingSymbol);

		title = "<font color=\"#FAAC34\" size=\"28\" ><u>First person mode help</u></font>";
		mousepart = " " + bracketOpeningSymbol + "<font color=\"" + theGame.params.KEYBOARD_KEY_FONT_COLOR + "\">Right Mouse Button</font>" + bracketClosingSymbol + " ";
		mmbpart = " " + bracketOpeningSymbol + "<font color=\"" + theGame.params.KEYBOARD_KEY_FONT_COLOR + "\">Middle Mouse Button</font>" + bracketClosingSymbol + " ";
		message = "Hello and welcome to the <font color=\"#FF3939\"> First Person Mod</font>" + userpart + "<br>Mod is hooked by using <font color=\"#FF3939\">fphook</font> command. To change your field of view use <font color=\"#FF3939\">fpsetfov(x)</font> command (replace x with your desired FOV value). You can toggle head bobbing on or off with <font color=\"#FF3939\">fpzcorrect(0/1)</font>, your current FP settings can be checked by using <font color=\"#FF3939\">fpsettings</font> command. Mouse sensitivity can be adjusted via <font color=\"#FF3939\">fpsens(X,Y)</font> command. Entering/exiting first person mode is done by pressing" + GetIconForKey(IK_P) + "key on the keyboard. Additionally, first person specific DOF can be enabled or disabled by using <font color=\"#FF3939\">fpsetdof(0/1)</font> command, combat avoidance mode can be enabled by using <font color=\"#FF3939\">fpdonotdisturb(0/1)</font> command, vertical axis can be inverted for controller by using <font color=\"#FF3939\">fpinverty(0/1)</font> command. When in first person mode, you can press" + GetIconForKey(IK_1) + "to do a 180 degree turn," + GetIconForKey(IK_2) + "to center your view and" + mousepart + "to zoom in the view (" + mmbpart + "If you're currently playing as Ciri).<br>You can bring the help screen back at any time by writing <font color=\"#FF3939\">fphelp</font> in console.";

		theSound.SoundEvent("gui_global_panel_open");
		theGame.GetGuiManager().ShowUserDialogAdv(0, title, "<p align=\"justify\">" + message + "</p>" + "<br><br><br><p align=\"right\"> <font color=\"#003466\" alpha=\"#1B\">Created by: SkacikPL</font></p>", false, UDB_Ok);
	}

//Change mouse sensitivty for FP
	exec function fpsens(Xval, Yval : int)
	{
		var ent : CEntity;
		
		ent = theGame.GetEntityByTag( 'FPSCAMERA' );

		//Clamp that shit, bro
		Xval = Clamp(Xval,0,100);
		Yval = Clamp(Yval,0,100);

		theSound.SoundEvent("gui_global_clock_tick_stop");
		((FirstPersonCamera)ent).setsens(Xval,Yval);
		FactsSet("FPXSENS",Xval);
		FactsSet("FPYSENS",Yval);
		((FirstPersonCamera)ent).LogMessage("<font color=\"#C20095\">FP mouse sensitivity set to : </font>" + "<font color=\"#6D6169\">" + FactsQuerySum("FPXSENS") + " on X axis, and " + FactsQuerySum("FPYSENS") + " on Y axis." + "</font>");
	}

//Listener class
class FPHookListener extends CPlayerInput
{
	//Initialization function - register listener
	function StartListener(optional notrigger : bool)
	{
		theInput.RegisterListener( this, 'OnHook', 'DebugInput' );
	
		if(!notrigger)
		{
		theSound.SoundEvent("gui_ingame_wheel_open");
		LogMessage("<font color=\"#C20095\">First person mode hooked, press " + GetIconForKey(IK_P) + " on keyboard to enter/exit first person mode.</font>");
		}

	}
	
	event OnHook( action : SInputAction )
	{
		var ent : CEntity;
		var template : CEntityTemplate;
		var attachvector : Vector;
		var attachangle : EulerAngles;	
		var l_comp : CComponent;	
		var initialrotation : EulerAngles;
	
		//Entire spawning logic fired when player presses P
			if( IsPressed( action ) )
			{
				if(!thePlayer.GetIsHorseMounted() && !thePlayer.IsInCombatState())
				{
					template = (CEntityTemplate)LoadResource("dlc\fpcamfix\data\gameplay\camera\firstperson.w2ent", true);
					ent = theGame.CreateEntity(template, thePlayer.GetBoneWorldPosition('Root'), thePlayer.GetWorldRotation());	
					((FirstPersonCamera)ent).setlistener(this);	
	
					attachvector = thePlayer.GetBoneWorldPosition('Root');
					attachvector.Z = attachvector.Z + 1.85;
					attachangle = thePlayer.GetWorldRotation();
					attachangle.Pitch = 0;	
					attachangle.Roll = 0;	
	
					ent.CreateAttachmentAtBoneWS( thePlayer, 'Root', attachvector, attachangle );
					ent.AddTag('FPSCAMERA');	
					initialrotation.Pitch = initialrotation.Pitch * -1;
					initialrotation.Yaw = 0;	
					initialrotation.Roll = initialrotation.Roll * -1;
			
					l_comp = ent.GetComponentByClassName('CCameraComponent');
					((CComponent)l_comp).SetPosition(Vector(0,0.05,0,1));	
					((CComponent)l_comp).SetRotation(initialrotation);
				}
				else
				{
					LogMessage("<font color=\"#C20095\">Cannot enter first person mode right now.</font>");
					theSound.SoundEvent("gui_global_denied");
				}
			}
	}

//Print to log
	public function LogMessage(m : string)
	{
		var str : string;	
	
		str = ReplaceTagsToIcons(m);
	
		theGame.GetGuiManager().ShowNotification(str, 4000);
	}	
}

//Needed for FOV controls
import class CCameraComponent extends CSpriteComponent
{
	import var fov	:	float;
	
public function setfov(val : float)
{
	fov = val;
}

public function getfov() : float
{
	return fov;
}
}